'use strict';

var chunkLKG3VLCP_js = require('./chunk-LKG3VLCP.js');
var chunkQEE7GVZV_js = require('./chunk-QEE7GVZV.js');
var chunkH736K5TN_js = require('./chunk-H736K5TN.js');
var algos = require('@lsk4/algos');
var err = require('@lsk4/err');

function RmqErrorCallback(channel, msg, err$1) {
  const isLog = chunkQEE7GVZV_js.getRmqConfig("isLog") || false;
  if (isLog)
    chunkLKG3VLCP_js.log.error("[RmqErrorCallback]", err$1);
  const { replyTo, correlationId } = msg.properties;
  if (err$1?.status === 300 || err$1?.__err && err$1?.rd) {
    const { routingKey, exchange } = msg.fields;
    const rd = typeof err$1?.rd === "string" ? err$1?.rd : `${routingKey}_rd`;
    const { pattern, data, ...meta } = err$1.meta || {};
    const payload = algos.omitNull({
      pattern,
      data,
      err: err.Err.getJSON(err$1) || err.Err.getCode(err$1),
      meta: {
        ...meta,
        exchange,
        routingKey
      }
    });
    channel.publish("", rd, Buffer.from(JSON.stringify(payload)));
  }
  if (replyTo) {
    let error;
    if (err$1?.__err) {
      error = JSON.stringify(err$1);
    } else if (err$1 instanceof Error) {
      error = JSON.stringify({
        code: err$1?.code || err$1?.name || 1,
        message: err$1?.message
      });
    } else if (typeof err$1 === "string") {
      error = JSON.stringify({
        code: 1,
        message: err$1
      });
    } else {
      error = JSON.stringify(err$1);
    }
    channel.publish("", replyTo, Buffer.from(error), {
      correlationId
    });
  }
  if (err$1?.status === 200 || err$1?.status === 300) {
    channel.nack(msg, false, false);
  } else {
    channel.nack(msg, false, true);
  }
}
chunkH736K5TN_js.__name(RmqErrorCallback, "RmqErrorCallback");

exports.RmqErrorCallback = RmqErrorCallback;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=chunk-J5FW2BT7.js.map